import getPageHeight from '../dom/get-page-height';

export default function pointerCoords() {
    let self = null;

    function calculateCoords(event) {
        const touch = event.touches && event.touches.length;
        const p = touch ? event.touches[0] : event;
        const cX = p.clientX || 0;
        const cY = p.clientY || 0;
        const pX = window.pageXOffset;
        const pY = window.pageYOffset;
        self.event = event;
        self.clientX = cX;
        self.clientY = cY;
        self.x = cX + pX;
        self.y = cY + pY;
        self.percentX = self.x / window.innerWidth;
        self.percentY = self.y / getPageHeight();
    }

    self = {
        event: null,
        clientX: 0,
        clientY: 0,
        x: 0,
        y: 0,
        percentX: 0,
        percentY: 0,
        isListening: false,

        on: function() {
            document.body.addEventListener('mousemove', calculateCoords);
            document.body.addEventListener('touchmove', calculateCoords);
            self.isListening = true;
            return this;
        },
        off: function() {
            document.body.removeEventListener('mousemove', calculateCoords);
            document.body.removeEventListener('touchmove', calculateCoords);
            self.isListening = false;
            return this;
        }
    };
    return self;
}
